﻿
using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;

namespace Affine_transforms
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        Point[] Vertices = new Point[4];

        Point PrevPoint;
        Line[] Rect = new Line[4];

        public Window1()
        {
            InitializeComponent();

            // inicializacia
        }

        // vykreslovanie obdlznika
        public void DrawRectangle(Point[] vertices)
        {
            for (int i = 0; i < 4; i++)
            {
                Rect[i].X1 = vertices[i].X;
                Rect[i].Y1 = vertices[i].Y;
                Rect[i].X2 = vertices[(i + 1) % 4].X;
                Rect[i].Y2 = vertices[(i + 1) % 4].Y;
            }
        }

        // posunutie -- pre jednoduchost vyuzijeme zapis po suradniciach
        public Point[] Translate(Point[] vertices, Vector dir)
        {
            Point[] output = new Point[4];

            return output;
        }

        // skalovanie prebieha vzhladom na tazisko objektu
        // t. j. musime najprv tazisko obdlznika presunut do pociatku sur. sustavy, nasledne preskalovat a potom obdlznik presunut na povodne miesto
        public Point[] Scale(Point[] vertices, Vector factor)
        {
            Point[] output = new Point[4];

            // suradnice taziska objektu (pevne dane)    

            // vektor, ktory posunie tazisko do zaciatku sur. sustavy

            // vykoname samotne posunutie s prislusnymi parametrami

            // nasledne kazdy vrchol obdlznika preskalujeme

            // obdlznik posunieme spat na povodne miesto

            return output;
        }

        // podobne ako v pripade skalovania, rotaciu urobime tiez vhladom na tazisko obdlznika
        public Point[] Rotate(Point[] vertices, Double angle)
        {
            Point[] output = new Point[4];

            // suradnice taziska objektu (pevne dane)   

            // vektor, ktory posunie tazisko do zaciatku sur. sustavy

            // vykoname samotne posunutie s prislusnymi parametrami

            // jednotlive vrcholy obdlznika zrotujeme

            // obdlznik posunieme spat na povodne miesto

            return output;
        }

        private void g_MouseDown(object sender, MouseButtonEventArgs e)
        {           
            // definujeme poziciu vrcholov obdlznika, ktory je vo vychodiskovej polohe v pripade posunutia
        }

        private void g_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                if (rbTranslate.IsChecked == true)
                {
                    
                    // vypocet vektoru posunutia

                    // zavolanie transformacie
                    
                    //vykreslenie
                    
                    // prepiseme poziciu predosleho bodu, aby sme vedeli opat vypocitat vektor posunutia
                    
                }

                if (rbScale.IsChecked == true)
                {
                    // v pripade skalovania budeme pracovat s pevne danym obdlznikom

                    
                    // koeficienty skalovania pocitame vzhladom na pevne tazisko obdlznika (kedze nechceme aby sa obdlznik posuval)
                }

                if (rbRotate.IsChecked == true)
                {
                    // aj v pripade otacania budeme pracovat s pevne danym obdlznikom

                    // uhol pocitame z polarnych suradnic

                    // nakolko na vypocet pouzivame vztah pomocou skalarneho sucinu, rotacia funguje len v rozpati 0 az 180 stupnov
                }
            }
        }

        private void g_MouseUp(object sender, MouseButtonEventArgs e)
        {

        }
    }
}